import pcksniff.* ;

import java.util.* ;
import java.text.* ;


public class PcktFilter
{ 
  public static void main(String[] args)
  { 
    StringBuffer sb = new StringBuffer() ;
    
    if (args.length!=3) 
    { System.out.println("\nUsage: PcktFilter <device> <filter> <netmask>\n") ; 
      System.exit(-1) ;
    }
    
    // Parse the netmask
    //
    int netmask = 0 ;
    int sc = 32 ;
    StringTokenizer st = new StringTokenizer(args[2],".") ;
    try
    {   while (st.hasMoreTokens())
	    {  sc -= 8 ;
	       int x = Integer.parseInt(st.nextToken()) ;
	       if ((x<0)||(x>255)) throw new Exception() ;
	       x <<= sc ;
	       netmask |= x ;    	
	    }
	    if (sc!=0) throw new Exception() ;
    }
    catch(Exception ex)
    { System.out.println("Invalid netmask.") ;
      System.exit(-1) ; 
    } 
    
    Adapter adapter = Sniffer.openLive(args[0],1600,1,1,sb) ;
               
    if (adapter.isNull())
    { System.out.println(sb) ;
      System.exit(-1) ;
    }
        
    // Compiles the filter 
    //   
    BpfProgram bpf_prog = Sniffer.allocateBpfProgram() ;
    
    int retVal = Sniffer.compile(adapter,bpf_prog,args[1],0,netmask) ;
    
    if (retVal!=0)
    { System.out.println("\nSyntax error in filter expression.") ;
      System.exit(-1) ;
    }
    
    // Sets the filter
    //    
    retVal = Sniffer.setFilter(adapter,bpf_prog) ;
    
    if (retVal!=0)
    { System.out.println("\nError setting the filter.") ;
      System.exit(-1) ;
    }
                  
    PacketConsumer consumer = new PacketConsumer() 
                        {                           	
                          public void consume(long sec,long millis,byte[] packetData)
                          { 
                            // Gets the packet length
                            int pcktLength = packetData.length ;
                          
                            // Prints out the packet
                            //
                            System.out.print("\nTime : " + sec ) ;                               
                            for (int i=0;i<pcktLength;i++)
                            { 
                              // New line ever 16 bytes
                              //
                              if((i%40)==0) System.out.println() ;
                              
                              char c = (char)packetData[i] ;
                              if ((c<32)||(c>128)) c = '.' ;
                              
                              System.out.print(c) ;	
                              
                            }
                            System.out.println() ;
                                    
                          }
                        };     
    
    System.out.println("\nType enter to exit.\n") ;
        
    try
    {  while(System.in.available()==0)
       {  Sniffer.dispatch(adapter,consumer,-1) ;
       }
    }
    catch(Exception ex)
    { System.out.println(ex.getMessage()) ;
    }
    
    Sniffer.close(adapter) ;
    
  }
}
