import pcksniff.* ;

import java.text.* ;
import java.util.* ;

public class PcktViewer
{ public static void main(String[] args)
  { 
    StringBuffer sb = new StringBuffer() ;
    
    if (args.length!=1) 
    { System.out.println("\nUsage: PcktViewer <device>\n") ; 
      System.exit(-1) ;
    }
        
    Adapter adapter = Sniffer.openLive(args[0],1600,1,1,sb) ;
               
    if (adapter.isNull())
    { System.out.println(sb) ;
      System.exit(-1) ;
    }
    
    System.out.println("\nType enter to exit.\n") ;
       
   
    
    PacketConsumer consumer = new PacketConsumer() 
                        { 
                          // Chars array used to convert a byte into a hex string
                          //	
                          char[] hex = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'} ;
                          
                          // SimpleDateFormatter used to format the packet time
                          //
                          SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss .SSS") ;
                        	
                          public void consume(long sec,long millis,byte[] packetData)
                          { 
                            // Gets the packet length
                            //	
                            int pcktLength = packetData.length ;
                            
                            // Gets and formats the packet time
                            //
                            Date t = new Date(sec * 1000 + millis) ;
                            String time = sdf.format(t)  ;
                            
                            // Prints out the packet
                            //
                            System.out.println("\n" + time +  "  Size : " + pcktLength) ;                               
                            for (int i=0;i<pcktLength;i++)
                            { 
                              // New line ever 16 bytes
                              //
                              if((i%16)==0) System.out.println() ;
                              
                              // Converts a byte to two chars hex format
                              //
                              char hi_nib = hex[(packetData[i] & 0xF0)>>4] ;
                              char lo_nib = hex[(packetData[i] & 0x0F)] ;
                              
                              System.out.print("" + hi_nib + lo_nib + " " ) ;	
                              
                            }
                            System.out.println() ;        
                          }
                        };     
    
    try
    {  while(System.in.available()==0)
       {  Sniffer.dispatch(adapter,consumer,-1) ;
       }
    }
    catch(Exception ex)
    { System.out.println(ex.getMessage()) ;
    }
    
    Sniffer.close(adapter) ;
    
  }
}
