import pcksniff.* ;

public class TestLib
{ 
  public static void main(String[] args)
  { System.out.println("\nThe VM searches the library along this path:\n") ;
    System.out.println("  " + System.getProperty("java.library.path")) ;
    //
    System.out.println("\nThe VM maps the library name into this platform-specific native library:\n") ;
    System.out.println("  " + System.mapLibraryName("Sniffer")) ; 
    //
    System.out.print("\n\nLoading the library...") ;
    try
    { System.loadLibrary("Sniffer") ;
      System.out.println("OK. Library loaded.\n") ;
    }
    catch(Throwable ex) 
    { System.out.println("FAILED.") ;
      System.out.println("Please, check the name and the search path of the library.") ;
      System.out.println("Set the LD_LIBRARY_PATH environment variable to change the search path.") ; 
      System.exit(-1) ;
    }
    
    StringBuffer ebuff = new StringBuffer() ;
    
    String deviceName = Sniffer.lookupDev(ebuff) ;
    
    if (deviceName.equals("")) 
    { System.out.println(ebuff) ;
      System.exit(0) ;
    }
    
    int netMask = Sniffer.lookupNetMask(deviceName,ebuff) ;
    int netNumber = Sniffer.lookupNetNumber(deviceName,ebuff) ;
    
    System.out.println("\nDevices data:\n") ;
    System.out.println("Device name: " +  deviceName) ;
    System.out.println("Netmask:     " + ((netMask&0xFF000000)>>>24) + "." + ((netMask&0x00FF0000)>>>16) + "." + ((netMask&0x0000FF00)>>>8) + "." + (netMask&0x000000FF) ) ;
    System.out.println("IP :         " + ((netNumber&0xFF000000)>>>24) + "." + ((netNumber&0x00FF0000)>>>16) + "." + ((netNumber&0x0000FF00)>>>8) + "." + (netNumber&0x000000FF) ) ;    
  }
}
